import java.math.* ;
import java.util.* ;
/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/
class Eqs {
  BigInteger n ;
  int B ;
  Eq [] eq ;

  Eqs (BigInteger n, int B, Eq [] eq) {
    this.n = n ;
    this.B = B ;
    this.eq = eq ;
  }

  private Hashtable t = new Hashtable (101) ;
  private int next = 0 ;

  private void seePrime(int p) {
    Integer key = new Integer (p) ;

    Pair index = (Pair)t.get(key) ;
    if (index == null) {
      t.put(key, new Pair(next++, 1)) ;
    } else {
      index.count++ ;
    }
  }

  private int getIndex(int p) {
    Pair index = (Pair)t.get(new Integer(p)) ;
    int r = index.index ;
    return r ;
  }

  Row [] makeMatrix() {
    int nrows = eq.length ;
    Row [] mat = new Row [nrows] ;

    for (int i = 0 ; i < nrows ; i++) {
      for (IntList p = eq[i].ps ; p != null ; p = p.next) {
        if (p.val <= B) seePrime(p.val) ;
      }
    }

    System.err.println(nrows + " X " + next) ;

    // Arrange indices, st lower indices have higher frequencies
    // It saves a little memory in matrix rows
    Pair [] ps = new Pair [next] ;
    for (Enumeration e = t.elements() ; e.hasMoreElements() ; ) {
      Pair x = (Pair)e.nextElement() ;
      ps[x.index] = x ;
    }
    Arrays.sort(ps) ;
    for (int i = 0 ; i < next ; i++)
      ps[i].index = i ;

    for (int i = 0 ; i < nrows ; i++) {
      IntList r = null ;
      boolean largePrime = false ;
      for (IntList p = eq[i].ps ; p != null ; p = p.next) {
        if (p.val <= B) {
          r = new IntList (getIndex(p.val), r) ;
        } else {
          largePrime = true ;
        }
      }
      mat[i] = new Row(i, r) ;
      if (!largePrime) {
        eq[i].ps = null ; // spare a little memory
      }
    }

    t = null ; // spare more
    return mat ;
  }
}
